<html lang="en">

<head>
    <meta charset="UTF-8">
    <title> Lesson 4 :: Task 4 </title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="css/normalize.css" />
    <link rel="stylesheet" href="css/style.css" />
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css"
        integrity="sha384-HSMxcRTRxnN+Bdg0JdbxYKrThecOKuH5zCYotlSAcp1+c8xmyTe9GYg1l9a69psu" crossorigin="anonymous">
</head>

<body>

    <div class="container">

        <div class="row">

            <div class="col-md-3">
                <h3> Form 1 </h3>
                <form id="first_form">
                    <label>
                        <input class="form-control" name="title" />
                    </label>

                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="first_form_checkbox[]"> One
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="first_form_checkbox[]"> Two
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="first_form_checkbox[]"> Three
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="first_form_checkbox[]"> Four
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="first_form_checkbox[]"> Five
                        </label>
                    </div>
                    <button type="submit" class="btn btn-success">Send</button>
                </form>
            </div>

            <div class="col-md-3">
                <h3> Form 2 </h3>
                <form id="second_form">
                    <label>
                        <input class="form-control" name="title" />
                    </label>

                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_one[]"> One
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_one[]"> Two
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_one[]"> Three
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_one[]"> Four
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_one[]"> Five
                        </label>
                    </div>

                    <b> Checkbox 2</b>

                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_two[]"> One
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_two[]"> Two
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_two[]"> Three
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_two[]"> Four
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="second_form_checkbox_two[]"> Five
                        </label>
                    </div>

                    <button type="submit" class="btn btn-success">Send</button>
                </form>
            </div>

            <div class="col-md-3">
                <h3> Form 3 </h3>
                <form id="third_form">
                    <label>
                        <input class="form-control" name="title" />
                    </label>

                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="third_form_checkbox[]"> One
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="third_form_checkbox[]"> Two
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="third_form_checkbox[]"> Three
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="third_form_checkbox[]"> Four
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="third_form_checkbox[]"> Five
                        </label>
                    </div>
                    <button type="submit" class="btn btn-success">Send</button>
                </form>
            </div>

            <div class="col-md-3">
                <h3> Form 4 </h3>
                <form id="fourth_form">
                    <label>
                        <input class="form-control" name="title" />
                    </label>

                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="fourth_form_checkbox[]"> One
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="fourth_form_checkbox[]"> Two
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="fourth_form_checkbox[]"> Three
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="fourth_form_checkbox[]"> Four
                        </label>
                    </div>
                    <div class="checkbox">
                        <label>
                            <input class="_checkbox" type="checkbox" name="fourth_form_checkbox[]"> Five
                        </label>
                    </div>
                    <button type="submit" class="btn btn-success">Send</button>
                </form>
            </div>
        </div>


    </div>


    <script>

        /*
            Задание 4.


            1) Нужно написать функцию которая будет находить чекбоксы внутри формы
            и добавлять лимиты на количество элементов, которые могут быть выбраны внутри этой формы.

            Вызов должен выглядеть так:

            formCheckboxLimit( form_id, checkbox_name, limits );

            В результате внутри выбранной формы {form_id}, чекбоксы с указанным именем {checkbox_name} не должны выбираться больше чем
            количество указанное в {limits}.

            2) Нужно написать функцию, которая будет делать те же самые лимиты, что и в задании 1.
            Но инициализация этого функционала должна проходить не явно, а по наличию класса на чекбоксе.

            Т.е например мы находим все элементы формы которые имеют определенный класс и делаем проверку,
            которая не будет позволять выбрать больше чем {2} элемента с одинаковым неймом.

        */

        let form_id = "third_form"
        let checkbox_name = "third_form_checkbox[]"
        let limits = 2

        function formCheckboxLimit(form_id, checkbox_name, limits) {
            let form = document.forms[form_id];

            let inputs = form.querySelectorAll("input")
            let checkboxes = []
            let selectedNum = 0;
            inputs.forEach((input) => {
                if (input.type === "checkbox" && input.name === checkbox_name) {
                    checkboxes.push(input)
                    input.addEventListener('click', function (e) {
                        const checked_elements = document.querySelectorAll("._checkbox[name='" + checkbox_name + "']:checked");
                        if (checked_elements.length > limits) {
                            e.preventDefault();
                        }
                    });
                    if (input.checked === true) {
                        if (selectedNum < limits) {
                            selectedNum++
                        }
                    }

                }
            })
        }

        formCheckboxLimit(form_id, checkbox_name, limits);

        let form_id2 = "second_form"
        let checkbox_name2 = "second_form_checkbox_two[]"
        let limits2 = 2

        let form2 = document.getElementById(form_id2)
        let checkboxesWithClass2 = form2.querySelectorAll("._checkbox[name='" + checkbox_name2 + "']")

        let limited = "limited"
        // set up limited class
        checkboxesWithClass2.forEach(checkbox => { checkbox.classList.add(limited) })

        let form_id4 = "fourth_form"
        let checkbox_name4 = "fourth_form_checkbox[]"

        let form4 = document.getElementById(form_id4)
        let checkboxesWithClass4 = form4.querySelectorAll("._checkbox[name='" + checkbox_name4 + "']")

        // set up limited class
        checkboxesWithClass4.forEach(checkbox => { checkbox.classList.add(limited) })

        function formCheckboxLimit2(limited, limits2) {

            Array.from(document.forms).forEach(form => {
                let inputsLimited = form.querySelectorAll("." + limited)
                inputsLimited.forEach(input => {
                    input.addEventListener('click', function (e) {
                        let inputsLimitedChecked = form.querySelectorAll("." + limited + ":checked")

                        if (inputsLimitedChecked.length > limits2) {
                            e.preventDefault();
                        }
                    });
                });
            });
        }
        formCheckboxLimit2(limited, limits2)
    </script>
</body>

</html>